var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  CollectionNotFoundException: () => CollectionNotFoundException,
  ConfigurationException: () => ConfigurationException,
  ConflictException: () => ConflictException,
  IndexNotFoundException: () => IndexNotFoundException,
  InvalidBatchReplaceDeleteDescriptorException: () => InvalidBatchReplaceDeleteDescriptorException,
  InvalidCompositeConditionException: () => InvalidCompositeConditionException,
  InvalidIdException: () => InvalidIdException,
  InvalidIndexedFieldValueException: () => InvalidIndexedFieldValueException,
  InvalidParentIdException: () => InvalidParentIdException,
  InvalidQueryException: () => InvalidQueryException,
  InvalidUpdateValueException: () => InvalidUpdateValueException,
  InvalidUpdatesException: () => InvalidUpdatesException,
  batchFindByIds: () => batchFindByIds,
  batchReplaceDelete: () => batchReplaceDelete,
  createContext: () => createContext,
  deleteById: () => deleteById,
  deleteChildById: () => deleteChildById,
  find: () => find,
  findById: () => findById,
  findByIdWithChildren: () => findByIdWithChildren,
  findChildById: () => findChildById,
  findChildren: () => findChildren,
  insert: () => insert,
  replace: () => replace,
  updateById: () => updateById,
  updateChildById: () => updateChildById
});
module.exports = __toCommonJS(src_exports);

// src/base/exceptions.ts
var import_verror = require("verror");
var ConflictException = class extends import_verror.VError {
  constructor(message, id) {
    super({ info: { id }, name: "conflict.error" }, message);
  }
};
var InvalidIdException = class extends import_verror.VError {
  constructor(id) {
    super({ info: { id }, name: "invalid_id.error" }, "The provided document has an invalid ID");
  }
};
var InvalidParentIdException = class extends import_verror.VError {
  constructor(parentId, collectionName, parentCollectionName) {
    super({
      info: {
        parentId,
        collectionName,
        parentCollectionName
      },
      name: "invalid_parent_id.error"
    }, `The provided document has a missing parent ID or it is the incorrect type`);
  }
};
var CollectionNotFoundException = class extends import_verror.VError {
  constructor(collection) {
    super({ info: { collection }, name: "collection_not_found.error" }, `Collection not found: '${collection}'`);
  }
};
var IndexNotFoundException = class extends import_verror.VError {
  constructor(index) {
    super({ info: { index }, name: "index_not_found.error" }, `Index not found: ${index}`);
  }
};
var ConfigurationException = class extends import_verror.VError {
  constructor(message, options = {}) {
    super(__spreadProps(__spreadValues({}, options), {
      name: "configuration.error"
    }), message);
  }
};
var InvalidIndexedFieldValueException = class extends import_verror.VError {
  constructor(message, { collection, keyPath }) {
    super({
      info: {
        collection,
        keyPath
      },
      name: "invalid_indexed_field_value.error"
    }, message);
  }
};
var InvalidQueryException = class extends import_verror.VError {
  constructor(message, { collection, query }) {
    super({
      info: {
        collection,
        query
      },
      name: "invalid_query.error"
    }, message);
  }
};
var InvalidUpdatesException = class extends import_verror.VError {
  constructor(message) {
    super({
      name: "invalid_updates.error"
    }, message);
  }
};
var InvalidUpdateValueException = class extends import_verror.VError {
  constructor(path, message) {
    super({
      name: "invalid_update_value",
      info: {
        path
      }
    }, message);
  }
};
var InvalidFindDescriptorException = class extends import_verror.VError {
  constructor(message) {
    super({
      name: "invalid_find_descriptor"
    }, message);
  }
};
var InternalProcessingException = class extends import_verror.VError {
  constructor(message) {
    super({ name: "internal_processing" }, message);
  }
};
var printParsePath = (parsePath) => {
  return parsePath.map((e) => {
    if (e.type === "array")
      return e.index === 0 ? `[` : `[...@${e.index}:`;
    return `{ ${e.key}: `;
  }).join("");
};
var InvalidCompositeConditionException = class extends import_verror.VError {
  constructor(message, parsePath) {
    super({
      name: "invalid_composite_condition",
      info: { parsePath }
    }, `Condition parse exception: ${message} at ${printParsePath(parsePath)}`);
  }
};
var InvalidBatchReplaceDeleteDescriptorException = class extends import_verror.VError {
  constructor(message, info) {
    super({ name: "invalid_batch_replace_descriptor", info }, message);
  }
};
var InvalidRangeOperatorException = class extends import_verror.VError {
  constructor(message, operator) {
    super({ name: "invalid_range_operator", info: { operator } }, message);
  }
};

// src/context/validators.ts
function validateFindKeys(findKeys) {
  const alreadyDefinedIndexes = [];
  findKeys.forEach((findKey, index) => {
    if (alreadyDefinedIndexes.includes(findKey.indexName)) {
      throw new ConfigurationException(`find key at index ${index} has duplicate index reference ${findKey.indexName}`);
    }
    alreadyDefinedIndexes.push(findKey.indexName);
  });
}

// src/base/access_pattern.ts
var describeKeyPath = (keyPath) => keyPath.join(".");
var describeAccessPattern = ({
  indexName,
  partitionKeys,
  sortKeys
}) => `[access pattern index=${indexName} partition=${partitionKeys.join(",")} ${sortKeys ? `sort=${sortKeys.join(",")}` : ""}]`;

// src/context/extract_keys.ts
var withTypeCreateExtractKey = (type) => (key, valuePaths, options) => ({
  type,
  key,
  valuePaths,
  options: options || {}
});
var createPartitionExtractKey = withTypeCreateExtractKey("partition");
var createSortExtractKey = withTypeCreateExtractKey("sort");
function buildAndValidateAccessPatterns(collection) {
  const wrapperExtractKeys = [];
  const findKeys = collection.layout.findKeys || [];
  const usedIndexes = [];
  for (const accessPattern of collection.accessPatterns || []) {
    const { indexName } = accessPattern;
    if (usedIndexes.includes(indexName)) {
      throw new ConfigurationException(`accessPattern ${describeAccessPattern(accessPattern)} refers to index in use by another pattern`);
    }
    usedIndexes.push(indexName);
    const layout = findKeys.find((key) => key.indexName === indexName);
    if (!layout) {
      throw new ConfigurationException(`access pattern ${describeAccessPattern(accessPattern)} refers to index missing from layout`);
    }
    wrapperExtractKeys.push(createPartitionExtractKey(layout.partitionKey, accessPattern.partitionKeys, accessPattern.options));
    if (accessPattern.sortKeys) {
      if (!layout.sortKey) {
        throw new ConfigurationException(`access pattern ${describeAccessPattern(accessPattern)} has sort keys but index ${indexName} does not`);
      }
      wrapperExtractKeys.push(createSortExtractKey(layout.sortKey, accessPattern.sortKeys, accessPattern.options));
    } else if (!accessPattern.sortKeys && layout.sortKey) {
      throw new ConfigurationException(`access pattern ${describeAccessPattern(accessPattern)} does not have sort keys but index ${indexName} has one defined - values in this collection will not show up`);
    }
  }
  return wrapperExtractKeys;
}

// src/context/index.ts
var import_isEqual = __toESM(require("lodash/isEqual"));
function createContext(dynamodb, collections) {
  const definitions = /* @__PURE__ */ new Map();
  const rootDefinitions = /* @__PURE__ */ new Map();
  const childDefinitions = /* @__PURE__ */ new Map();
  for (const collection of collections) {
    const { name, layout } = collection;
    if (definitions.has(name)) {
      throw new ConfigurationException(`Duplicate collection definition: '${name}'`);
    }
    if (layout.findKeys) {
      validateFindKeys(layout.findKeys);
    }
    let wrapperExtractKeys = [];
    if (collection.accessPatterns) {
      wrapperExtractKeys = buildAndValidateAccessPatterns(collection);
    }
    if (collection.ttlKeyPath) {
      const { ttlKeyPath } = collection;
      if (!layout.ttlAttribute) {
        throw new ConfigurationException(`Collection '${name}' defines ttlKeyPath=${describeKeyPath(ttlKeyPath)} but layout has no ttlAttribute specified`);
      }
      const ttlExtractKey = {
        type: "ttl",
        key: layout.ttlAttribute,
        valuePaths: [ttlKeyPath],
        options: {}
      };
      wrapperExtractKeys = [...wrapperExtractKeys, ttlExtractKey];
    }
    definitions.set(collection.name, __spreadProps(__spreadValues({}, collection), {
      wrapperExtractKeys
    }));
    if (collection.type === "child") {
      childDefinitions.set(collection.name, __spreadProps(__spreadValues({}, collection), {
        wrapperExtractKeys
      }));
    } else {
      rootDefinitions.set(collection.name, __spreadProps(__spreadValues({}, collection), {
        wrapperExtractKeys
      }));
    }
  }
  for (const childDefinition of childDefinitions.values()) {
    const parentDefinition = rootDefinitions.get(childDefinition.parentCollectionName);
    if (!parentDefinition) {
      throw new ConfigurationException(`Child collection ${childDefinition.name} refers to non-existent parent definition ${childDefinition.parentCollectionName}`);
    }
    if (!(0, import_isEqual.default)(parentDefinition.layout, childDefinition.layout)) {
      throw new ConfigurationException(`Child collection ${childDefinition.name} must have same layout as parent definition ${parentDefinition.name}`);
    }
  }
  return {
    ddb: dynamodb,
    definitions,
    rootDefinitions,
    childDefinitions,
    __TYPE__: "DynaglueContext"
  };
}

// src/operations/find_by_id.ts
var import_dynamodb = require("aws-sdk/clients/dynamodb");

// src/base/util.ts
var import_get = __toESM(require("lodash/get"));
var import_isISO8601 = __toESM(require("validator/lib/isISO8601"));

// src/base/new_id.ts
var import_crypto = require("crypto");
var PROCESS_UNIQUE = (0, import_crypto.randomBytes)(5);
var IdIndex = ~~(Math.random() * 16777215);
var getInc = () => IdIndex = (IdIndex + 1) % 16777215;
var newId = () => {
  const time = ~~(Date.now() / 1e3);
  const inc = getInc();
  const buffer = Buffer.alloc(12);
  buffer[3] = time & 255;
  buffer[2] = time >> 8 & 255;
  buffer[1] = time >> 16 & 255;
  buffer[0] = time >> 24 & 255;
  buffer[4] = PROCESS_UNIQUE[0];
  buffer[5] = PROCESS_UNIQUE[1];
  buffer[6] = PROCESS_UNIQUE[2];
  buffer[7] = PROCESS_UNIQUE[3];
  buffer[8] = PROCESS_UNIQUE[4];
  buffer[11] = inc & 255;
  buffer[10] = inc >> 8 & 255;
  buffer[9] = inc >> 16 & 255;
  return buffer.toString("hex");
};
var new_id_default = newId;

// src/base/util.ts
var SEPARATOR = "|-|";
var assemblePrimaryKeyValue = (collectionName, _id, separator = SEPARATOR) => `${collectionName}${separator}${_id}`;
var assembleIndexedValue = (keyType, collectionName, values, separator = SEPARATOR) => {
  if (values.length === 0) {
    return collectionName;
  } else if (values.every((value) => typeof value === "undefined")) {
    return keyType === "partition" ? collectionName : void 0;
  }
  return `${collectionName}${separator}${values.map((x) => typeof x === "string" ? x : "").join(separator)}`;
};
var getRootCollection = (context, collectionName) => {
  const c = context.rootDefinitions.get(collectionName);
  if (!c)
    throw new CollectionNotFoundException(collectionName);
  return c;
};
var getChildCollection = (context, collectionName) => {
  const c = context.childDefinitions.get(collectionName);
  if (!c)
    throw new CollectionNotFoundException(collectionName);
  return c;
};
var getCollection = (context, collectionName) => {
  const c = context.definitions.get(collectionName);
  if (!c)
    throw new CollectionNotFoundException(collectionName);
  return c;
};
var transformTTLValue = (ttlValue) => {
  let transformedValue;
  if (typeof ttlValue === "object" && ttlValue instanceof Date) {
    transformedValue = Math.ceil(ttlValue.getTime() / 1e3);
  } else if (typeof ttlValue === "number") {
    transformedValue = Math.ceil(ttlValue / 1e3);
  } else if (typeof ttlValue === "string" && (0, import_isISO8601.default)(ttlValue)) {
    transformedValue = Math.ceil(new Date(ttlValue).getTime() / 1e3);
  }
  return transformedValue;
};
var extractTransformedTTLValue = (value, valuePath) => {
  const ttlValue = (0, import_get.default)(value, valuePath);
  return transformTTLValue(ttlValue);
};
var constructKeyValue = (type, collectionName, separator, valuePaths, options, value) => {
  if (type === "ttl") {
    return extractTransformedTTLValue(value, valuePaths[0]);
  }
  const values = valuePaths.map((valuePath) => {
    const extractedValue = (0, import_get.default)(value, valuePath);
    if (typeof extractedValue !== "undefined" && typeof extractedValue !== "string") {
      throw new InvalidIndexedFieldValueException(`Indexed value at path ${describeKeyPath(valuePath)} was not a string for collection ${collectionName}`, { keyPath: valuePath, collection: collectionName });
    }
    const transformedValue = options.stringNormalizer && extractedValue ? options.stringNormalizer(valuePath, extractedValue) : extractedValue;
    return transformedValue;
  });
  return assembleIndexedValue(type, collectionName, values, separator);
};
var toWrapped = (collection, value) => {
  let updatedValue;
  if (typeof value._id !== "undefined") {
    if (typeof value._id !== "string") {
      throw new InvalidIdException(value._id);
    }
    updatedValue = value;
  } else {
    const _id = collection.idGenerator ? collection.idGenerator() : new_id_default();
    updatedValue = __spreadProps(__spreadValues({}, value), { _id });
  }
  const extractedKeys = collection.wrapperExtractKeys.map(({ type, key, valuePaths, options }) => {
    var _a;
    const keyValue = constructKeyValue(type, collection.name, (_a = collection.layout.indexKeySeparator) != null ? _a : SEPARATOR, valuePaths, options, updatedValue);
    if (typeof keyValue !== void 0) {
      return { [key]: keyValue };
    }
  }).filter((x) => typeof x !== "undefined");
  let partitionKeyValue;
  let sortKeyValue;
  if (collection.type === "child") {
    const parentId = (0, import_get.default)(value, collection.foreignKeyPath);
    if (typeof parentId !== "string") {
      throw new InvalidParentIdException(parentId, collection.name, collection.parentCollectionName);
    }
    partitionKeyValue = assemblePrimaryKeyValue(collection.parentCollectionName, parentId, collection.layout.indexKeySeparator);
    sortKeyValue = assemblePrimaryKeyValue(collection.name, updatedValue._id, collection.layout.indexKeySeparator);
  } else {
    partitionKeyValue = sortKeyValue = assemblePrimaryKeyValue(collection.name, updatedValue._id, collection.layout.indexKeySeparator);
  }
  const wrapped = Object.assign({
    [collection.layout.primaryKey.partitionKey]: partitionKeyValue,
    [collection.layout.primaryKey.sortKey]: sortKeyValue,
    value: updatedValue,
    type: collection.name
  }, ...extractedKeys);
  return wrapped;
};
var unwrap = (document) => {
  return document.value;
};
var invertMap = (map) => Object.assign({}, ...Array.from(map.entries(), ([k, v]) => ({ [v]: k })));
var isSubsetOfKeyPath = (mainPath, subsetPath) => subsetPath.every((key, index) => mainPath[index] === key);
var findMatchingPath = (keyPaths, path) => {
  for (const keyPath of keyPaths) {
    if (isSubsetOfKeyPath(path, keyPath)) {
      return keyPath;
    }
  }
};

// src/debug/debugDynamo.ts
var import_debug = __toESM(require("debug"));
var logger = (0, import_debug.default)("dynaglue:dynamodb");
function debugDynamo(operation, request) {
  logger("operation=%s request=%O", operation, request);
}
var debugDynamo_default = debugDynamo;

// src/operations/find_by_id.ts
async function findById(context, collectionName, id, options) {
  const collection = getRootCollection(context, collectionName);
  const request = {
    TableName: collection.layout.tableName,
    ConsistentRead: options == null ? void 0 : options.consistentRead,
    Key: import_dynamodb.Converter.marshall({
      [collection.layout.primaryKey.partitionKey]: assemblePrimaryKeyValue(collectionName, id, collection.layout.indexKeySeparator),
      [collection.layout.primaryKey.sortKey]: assemblePrimaryKeyValue(collectionName, id, collection.layout.indexKeySeparator)
    }, { convertEmptyValues: false })
  };
  debugDynamo_default("GetItem", request);
  const result = await context.ddb.getItem(request).promise();
  if (result.Item) {
    const wrapped = import_dynamodb.Converter.unmarshall(result.Item, {
      convertEmptyValues: false
    });
    return unwrap(wrapped);
  }
  return void 0;
}

// src/operations/insert.ts
var import_dynamodb2 = require("aws-sdk/clients/dynamodb");
var import_get2 = __toESM(require("lodash/get"));
async function insert(context, collectionName, value) {
  const collection = getCollection(context, collectionName);
  const wrapped = toWrapped(collection, value);
  let request;
  if (collection.type === "child") {
    request = {
      TableName: collection.layout.tableName,
      Item: import_dynamodb2.Converter.marshall(wrapped, { convertEmptyValues: false }),
      ReturnValues: "NONE",
      ConditionExpression: "attribute_not_exists(#parentIdAttribute) and attribute_not_exists(#childIdAttribute)",
      ExpressionAttributeNames: {
        "#parentIdAttribute": assemblePrimaryKeyValue(collection.parentCollectionName, (0, import_get2.default)(value, collection.foreignKeyPath), collection.layout.indexKeySeparator),
        "#childIdAttribute": assemblePrimaryKeyValue(collection.name, wrapped.value._id, collection.layout.indexKeySeparator)
      }
    };
  } else {
    request = {
      TableName: collection.layout.tableName,
      Item: import_dynamodb2.Converter.marshall(wrapped, { convertEmptyValues: false }),
      ReturnValues: "NONE",
      ConditionExpression: "attribute_not_exists(#idAttribute)",
      ExpressionAttributeNames: {
        "#idAttribute": assemblePrimaryKeyValue(collection.name, wrapped.value._id, collection.layout.indexKeySeparator)
      }
    };
  }
  try {
    debugDynamo_default("PutItem", request);
    await context.ddb.putItem(request).promise();
  } catch (error) {
    if (error.code === "ConditionalCheckFailedException") {
      throw new ConflictException("An item with this _id already exists", wrapped.value._id);
    }
    throw error;
  }
  return wrapped.value;
}

// src/operations/find.ts
var import_isEqual2 = __toESM(require("lodash/isEqual"));
var import_dynamodb4 = require("aws-sdk/clients/dynamodb");

// src/base/mappers.ts
var import_dynamodb3 = require("aws-sdk/clients/dynamodb");

// src/base/expression_util.ts
var DYNAMODB_RESERVED_WORDS = ["ABORT", "ABSOLUTE", "ACTION", "ADD", "AFTER", "AGENT", "AGGREGATE", "ALL", "ALLOCATE", "ALTER", "ANALYZE", "AND", "ANY", "ARCHIVE", "ARE", "ARRAY", "AS", "ASC", "ASCII", "ASENSITIVE", "ASSERTION", "ASYMMETRIC", "AT", "ATOMIC", "ATTACH", "ATTRIBUTE", "AUTH", "AUTHORIZATION", "AUTHORIZE", "AUTO", "AVG", "BACK", "BACKUP", "BASE", "BATCH", "BEFORE", "BEGIN", "BETWEEN", "BIGINT", "BINARY", "BIT", "BLOB", "BLOCK", "BOOLEAN", "BOTH", "BREADTH", "BUCKET", "BULK", "BY", "BYTE", "CALL", "CALLED", "CALLING", "CAPACITY", "CASCADE", "CASCADED", "CASE", "CAST", "CATALOG", "CHAR", "CHARACTER", "CHECK", "CLASS", "CLOB", "CLOSE", "CLUSTER", "CLUSTERED", "CLUSTERING", "CLUSTERS", "COALESCE", "COLLATE", "COLLATION", "COLLECTION", "COLUMN", "COLUMNS", "COMBINE", "COMMENT", "COMMIT", "COMPACT", "COMPILE", "COMPRESS", "CONDITION", "CONFLICT", "CONNECT", "CONNECTION", "CONSISTENCY", "CONSISTENT", "CONSTRAINT", "CONSTRAINTS", "CONSTRUCTOR", "CONSUMED", "CONTINUE", "CONVERT", "COPY", "CORRESPONDING", "COUNT", "COUNTER", "CREATE", "CROSS", "CUBE", "CURRENT", "CURSOR", "CYCLE", "DATA", "DATABASE", "DATE", "DATETIME", "DAY", "DEALLOCATE", "DEC", "DECIMAL", "DECLARE", "DEFAULT", "DEFERRABLE", "DEFERRED", "DEFINE", "DEFINED", "DEFINITION", "DELETE", "DELIMITED", "DEPTH", "DEREF", "DESC", "DESCRIBE", "DESCRIPTOR", "DETACH", "DETERMINISTIC", "DIAGNOSTICS", "DIRECTORIES", "DISABLE", "DISCONNECT", "DISTINCT", "DISTRIBUTE", "DO", "DOMAIN", "DOUBLE", "DROP", "DUMP", "DURATION", "DYNAMIC", "EACH", "ELEMENT", "ELSE", "ELSEIF", "EMPTY", "ENABLE", "END", "EQUAL", "EQUALS", "ERROR", "ESCAPE", "ESCAPED", "EVAL", "EVALUATE", "EXCEEDED", "EXCEPT", "EXCEPTION", "EXCEPTIONS", "EXCLUSIVE", "EXEC", "EXECUTE", "EXISTS", "EXIT", "EXPLAIN", "EXPLODE", "EXPORT", "EXPRESSION", "EXTENDED", "EXTERNAL", "EXTRACT", "FAIL", "FALSE", "FAMILY", "FETCH", "FIELDS", "FILE", "FILTER", "FILTERING", "FINAL", "FINISH", "FIRST", "FIXED", "FLATTERN", "FLOAT", "FOR", "FORCE", "FOREIGN", "FORMAT", "FORWARD", "FOUND", "FREE", "FROM", "FULL", "FUNCTION", "FUNCTIONS", "GENERAL", "GENERATE", "GET", "GLOB", "GLOBAL", "GO", "GOTO", "GRANT", "GREATER", "GROUP", "GROUPING", "HANDLER", "HASH", "HAVE", "HAVING", "HEAP", "HIDDEN", "HOLD", "HOUR", "IDENTIFIED", "IDENTITY", "IF", "IGNORE", "IMMEDIATE", "IMPORT", "IN", "INCLUDING", "INCLUSIVE", "INCREMENT", "INCREMENTAL", "INDEX", "INDEXED", "INDEXES", "INDICATOR", "INFINITE", "INITIALLY", "INLINE", "INNER", "INNTER", "INOUT", "INPUT", "INSENSITIVE", "INSERT", "INSTEAD", "INT", "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVALIDATE", "IS", "ISOLATION", "ITEM", "ITEMS", "ITERATE", "JOIN", "KEY", "KEYS", "LAG", "LANGUAGE", "LARGE", "LAST", "LATERAL", "LEAD", "LEADING", "LEAVE", "LEFT", "LENGTH", "LESS", "LEVEL", "LIKE", "LIMIT", "LIMITED", "LINES", "LIST", "LOAD", "LOCAL", "LOCALTIME", "LOCALTIMESTAMP", "LOCATION", "LOCATOR", "LOCK", "LOCKS", "LOG", "LOGED", "LONG", "LOOP", "LOWER", "MAP", "MATCH", "MATERIALIZED", "MAX", "MAXLEN", "MEMBER", "MERGE", "METHOD", "METRICS", "MIN", "MINUS", "MINUTE", "MISSING", "MOD", "MODE", "MODIFIES", "MODIFY", "MODULE", "MONTH", "MULTI", "MULTISET", "NAME", "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NCLOB", "NEW", "NEXT", "NO", "NONE", "NOT", "NULL", "NULLIF", "NUMBER", "NUMERIC", "OBJECT", "OF", "OFFLINE", "OFFSET", "OLD", "ON", "ONLINE", "ONLY", "OPAQUE", "OPEN", "OPERATOR", "OPTION", "OR", "ORDER", "ORDINALITY", "OTHER", "OTHERS", "OUT", "OUTER", "OUTPUT", "OVER", "OVERLAPS", "OVERRIDE", "OWNER", "PAD", "PARALLEL", "PARAMETER", "PARAMETERS", "PARTIAL", "PARTITION", "PARTITIONED", "PARTITIONS", "PATH", "PERCENT", "PERCENTILE", "PERMISSION", "PERMISSIONS", "PIPE", "PIPELINED", "PLAN", "POOL", "POSITION", "PRECISION", "PREPARE", "PRESERVE", "PRIMARY", "PRIOR", "PRIVATE", "PRIVILEGES", "PROCEDURE", "PROCESSED", "PROJECT", "PROJECTION", "PROPERTY", "PROVISIONING", "PUBLIC", "PUT", "QUERY", "QUIT", "QUORUM", "RAISE", "RANDOM", "RANGE", "RANK", "RAW", "READ", "READS", "REAL", "REBUILD", "RECORD", "RECURSIVE", "REDUCE", "REF", "REFERENCE", "REFERENCES", "REFERENCING", "REGEXP", "REGION", "REINDEX", "RELATIVE", "RELEASE", "REMAINDER", "RENAME", "REPEAT", "REPLACE", "REQUEST", "RESET", "RESIGNAL", "RESOURCE", "RESPONSE", "RESTORE", "RESTRICT", "RESULT", "RETURN", "RETURNING", "RETURNS", "REVERSE", "REVOKE", "RIGHT", "ROLE", "ROLES", "ROLLBACK", "ROLLUP", "ROUTINE", "ROW", "ROWS", "RULE", "RULES", "SAMPLE", "SATISFIES", "SAVE", "SAVEPOINT", "SCAN", "SCHEMA", "SCOPE", "SCROLL", "SEARCH", "SECOND", "SECTION", "SEGMENT", "SEGMENTS", "SELECT", "SELF", "SEMI", "SENSITIVE", "SEPARATE", "SEQUENCE", "SERIALIZABLE", "SESSION", "SET", "SETS", "SHARD", "SHARE", "SHARED", "SHORT", "SHOW", "SIGNAL", "SIMILAR", "SIZE", "SKEWED", "SMALLINT", "SNAPSHOT", "SOME", "SOURCE", "SPACE", "SPACES", "SPARSE", "SPECIFIC", "SPECIFICTYPE", "SPLIT", "SQL", "SQLCODE", "SQLERROR", "SQLEXCEPTION", "SQLSTATE", "SQLWARNING", "START", "STATE", "STATIC", "STATUS", "STORAGE", "STORE", "STORED", "STREAM", "STRING", "STRUCT", "STYLE", "SUB", "SUBMULTISET", "SUBPARTITION", "SUBSTRING", "SUBTYPE", "SUM", "SUPER", "SYMMETRIC", "SYNONYM", "SYSTEM", "TABLE", "TABLESAMPLE", "TEMP", "TEMPORARY", "TERMINATED", "TEXT", "THAN", "THEN", "THROUGHPUT", "TIME", "TIMESTAMP", "TIMEZONE", "TINYINT", "TO", "TOKEN", "TOTAL", "TOUCH", "TRAILING", "TRANSACTION", "TRANSFORM", "TRANSLATE", "TRANSLATION", "TREAT", "TRIGGER", "TRIM", "TRUE", "TRUNCATE", "TTL", "TUPLE", "TYPE", "UNDER", "UNDO", "UNION", "UNIQUE", "UNIT", "UNKNOWN", "UNLOGGED", "UNNEST", "UNPROCESSED", "UNSIGNED", "UNTIL", "UPDATE", "UPPER", "URL", "USAGE", "USE", "USER", "USERS", "USING", "UUID", "VACUUM", "VALUE", "VALUED", "VALUES", "VARCHAR", "VARIABLE", "VARIANCE", "VARINT", "VARYING", "VIEW", "VIEWS", "VIRTUAL", "VOID", "WAIT", "WHEN", "WHENEVER", "WHERE", "WHILE", "WINDOW", "WITH", "WITHIN", "WITHOUT", "WORK", "WRAPPED", "WRITE", "YEAR", "ZONE"];
var isReservedWord = (word) => DYNAMODB_RESERVED_WORDS.includes(word.toUpperCase());
var isSafeAttributeName = (attributeName) => {
  if (isReservedWord(attributeName)) {
    return false;
  }
  return /^[A-Za-z][A-Za-z0-9]*$/.test(attributeName);
};

// src/base/mappers.ts
var createNameMapper = () => {
  let currentIndex = 0;
  const attributeNameMap = /* @__PURE__ */ new Map();
  return {
    map(name, mappedName) {
      if (!mappedName && isSafeAttributeName(name)) {
        return name;
      }
      let nameMapping = attributeNameMap.get(name);
      if (!nameMapping) {
        nameMapping = mappedName != null ? mappedName : `#attr${currentIndex++}`;
        attributeNameMap.set(name, nameMapping);
      }
      return nameMapping;
    },
    get() {
      const result = invertMap(attributeNameMap);
      if (Object.keys(result).length === 0)
        return void 0;
      return result;
    }
  };
};
var createValueMapper = () => {
  let currentIndex = 0;
  const valueMap = /* @__PURE__ */ new Map();
  return {
    map(value) {
      const valueKey = `:value${currentIndex++}`;
      const convertedValue = import_dynamodb3.Converter.input(value, {
        convertEmptyValues: false
      });
      valueMap.set(valueKey, convertedValue);
      return valueKey;
    },
    get() {
      if (valueMap.size === 0)
        return void 0;
      return Array.from(valueMap).reduce((obj, [key, value]) => {
        obj[key] = value;
        return obj;
      }, {});
    }
  };
};

// src/base/conditions_parser.ts
var isConditionKey = (key) => [
  "$or",
  "$and",
  "$eq",
  "$neq",
  "$gt",
  "$gte",
  "$lt",
  "$lte",
  "$between",
  "$in",
  "$exists",
  "$type",
  "$beginsWith",
  "$contains"
].includes(key);
var mapKeyPath = (key, nameMapper) => [
  nameMapper.map("value", "#value"),
  ...key.split(".").map((pathElement) => nameMapper.map(pathElement))
].join(".");
var parseCompositeCondition = (clause, context) => {
  if (Object.keys(clause).length === 1) {
    if ("$and" in clause) {
      return parseAndCondition(clause, context);
    } else if ("$or" in clause) {
      return parseOrCondition(clause, context);
    } else if ("$not" in clause) {
      return parseNotCondition(clause, context);
    }
  }
  return parseKeyPathsAndClause(clause, context);
};
var parseAndCondition = (clause, context) => {
  const parsePath = [
    ...context.parsePath,
    { type: "object", key: "$and" }
  ];
  const updatedContextForIndex = (index) => __spreadProps(__spreadValues({}, context), {
    parsePath: [...parsePath, { type: "array", index }]
  });
  const subclauses = clause.$and.map((clause2, index) => parseCompositeCondition(clause2, updatedContextForIndex(index)));
  return subclauses.map((clause2) => `(${clause2})`).join(" AND ");
};
var parseOrCondition = (clause, context) => {
  const parsePath = [
    ...context.parsePath,
    { type: "object", key: "$or" }
  ];
  const updatedContextForIndex = (index) => __spreadProps(__spreadValues({}, context), {
    parsePath: [...parsePath, { type: "array", index }]
  });
  const subclauses = clause.$or.map((clause2, index) => parseCompositeCondition(clause2, updatedContextForIndex(index)));
  return subclauses.map((clause2) => `(${clause2})`).join(" OR ");
};
var parseNotCondition = (clause, context) => {
  const parsePath = [
    ...context.parsePath,
    { type: "object", key: "$not" }
  ];
  const updatedContext = __spreadProps(__spreadValues({}, context), { parsePath });
  const subclause = parseCompositeCondition(clause.$not, updatedContext);
  return `NOT ${subclause}`;
};
var parseKeyPathsAndClause = (clause, context) => {
  const { nameMapper, valueMapper, parsePath } = context;
  const paths = Object.keys(clause);
  if (paths.length < 1) {
    throw new InvalidCompositeConditionException("expected at least one key path with operator", parsePath);
  }
  const conditionKey = paths.find(isConditionKey);
  if (conditionKey) {
    const keyParsePath = [
      ...parsePath,
      { type: "object", key: conditionKey }
    ];
    throw new InvalidCompositeConditionException(`unexpected condition key`, keyParsePath);
  }
  const clauses = [];
  Object.entries(clause).forEach(([path, condition]) => {
    const keyParsePath = [
      ...parsePath,
      { type: "object", key: path }
    ];
    let clauseString;
    const simpleClause = (operator, value) => {
      const valueName = valueMapper.map(value);
      return `${mapKeyPath(path, nameMapper)} ${operator} ${valueName}`;
    };
    if ("$eq" in condition) {
      const value = condition.$eq;
      clauseString = simpleClause("=", value);
    } else if ("$neq" in condition) {
      const value = condition.$neq;
      clauseString = simpleClause("<>", value);
    } else if ("$gt" in condition) {
      const value = condition.$gt;
      clauseString = simpleClause(">", value);
    } else if ("$gte" in condition) {
      const value = condition.$gte;
      clauseString = simpleClause(">=", value);
    } else if ("$lt" in condition) {
      const value = condition.$lt;
      clauseString = simpleClause("<", value);
    } else if ("$lte" in condition) {
      const value = condition.$lte;
      clauseString = simpleClause("<=", value);
    } else if ("$between" in condition) {
      const value = condition.$between;
      if (!value || typeof value !== "object" || typeof value.$lte === "undefined" || typeof value.$gte === "undefined") {
        throw new InvalidCompositeConditionException("$between must be an object with values for $lte and $gte", keyParsePath);
      }
      const { $lte, $gte } = condition.$between;
      const value1 = valueMapper.map($gte);
      const value2 = valueMapper.map($lte);
      clauseString = `${mapKeyPath(path, nameMapper)} BETWEEN ${value1} AND ${value2}`;
    } else if ("$in" in condition) {
      if (!Array.isArray(condition.$in)) {
        throw new InvalidCompositeConditionException("$in must be an array of values", keyParsePath);
      }
      const values = condition.$in;
      if (values.length > 100) {
        throw new InvalidCompositeConditionException("$in condition has too many values", keyParsePath);
      } else if (values.length === 0) {
        throw new InvalidCompositeConditionException("$in condition must have at least one value", keyParsePath);
      }
      const valueNames = values.map((value) => valueMapper.map(value));
      clauseString = `${mapKeyPath(path, nameMapper)} IN (${valueNames.join(",")})`;
    } else if ("$exists" in condition) {
      const fn = condition.$exists ? "attribute_exists" : "attribute_not_exists";
      clauseString = `${fn}(${mapKeyPath(path, nameMapper)})`;
    } else if ("$type" in condition) {
      const valueName = valueMapper.map(condition.$type);
      clauseString = `attribute_type(${mapKeyPath(path, nameMapper)},${valueName})`;
    } else if ("$beginsWith" in condition) {
      const valueName = valueMapper.map(condition.$beginsWith);
      clauseString = `begins_with(${mapKeyPath(path, nameMapper)},${valueName})`;
    } else if ("$contains" in condition) {
      const valueName = valueMapper.map(condition.$contains);
      clauseString = `contains(${mapKeyPath(path, nameMapper)},${valueName})`;
    } else
      throw new InvalidCompositeConditionException("unknown operator", keyParsePath);
    clauses.push(clauseString);
  });
  return clauses.join(" AND ");
};

// src/operations/find.ts
var isEqualKey = (lhs, rhs) => {
  const normalisedLhs = typeof lhs === "string" ? lhs.split(".") : lhs;
  const normalisedRhs = typeof rhs === "string" ? rhs.split(".") : rhs;
  return (0, import_isEqual2.default)(normalisedLhs, normalisedRhs);
};
var findAccessPattern = (collection, query) => {
  return (collection.accessPatterns || []).find((ap) => {
    const unmatchedQueryKeys = [...Object.keys(query)];
    for (const apKey of ap.partitionKeys) {
      const matchingQueryKeyIndex = unmatchedQueryKeys.findIndex((queryKey) => isEqualKey(apKey, queryKey));
      if (matchingQueryKeyIndex >= 0) {
        unmatchedQueryKeys.splice(matchingQueryKeyIndex, 1);
      } else {
        return false;
      }
    }
    if (ap.sortKeys) {
      for (const apKey of ap.sortKeys) {
        const matchingQueryKeyIndex = unmatchedQueryKeys.findIndex((queryKey) => isEqualKey(apKey, queryKey));
        if (matchingQueryKeyIndex >= 0) {
          unmatchedQueryKeys.splice(matchingQueryKeyIndex, 1);
        } else {
          break;
        }
      }
    }
    return unmatchedQueryKeys.length === 0;
  });
};
var findAccessPatternLayout = (findKeys, ap) => findKeys.find((fk) => fk.indexName === ap.indexName);
var assembleQueryValue = (type, collectionName, query, options, paths, separator) => {
  if (paths) {
    const values = [];
    for (const path of paths) {
      const keyPath = path.join(".");
      const pathValue = query[keyPath];
      if (!pathValue)
        break;
      const scalarPathValue = type === "partition" || type === "sort" ? Array.isArray(pathValue) ? pathValue[0] : pathValue : Array.isArray(pathValue) ? pathValue[1] : void 0;
      if (!scalarPathValue)
        throw new InvalidIndexedFieldValueException("$between queries must specify an array for sort key values", { collection: collectionName, keyPath: path });
      const transformedValue = options.stringNormalizer ? options.stringNormalizer(path, scalarPathValue) : scalarPathValue;
      values.push(transformedValue);
    }
    return assembleIndexedValue(type === "sort2" ? "sort" : type, collectionName, values, separator);
  }
  return void 0;
};
var getQueryOperator = (sortKeyName, sortValueName, sortValueName2, qo) => {
  switch (qo) {
    case "lte":
      return `${sortKeyName} <= ${sortValueName}`;
    case "lt":
      return `${sortKeyName} < ${sortValueName}`;
    case "gte":
      return `${sortKeyName} >= ${sortValueName}`;
    case "gt":
      return `${sortKeyName} > ${sortValueName}`;
    case "equals":
      return `${sortKeyName} = ${sortValueName}`;
    case "between":
      return `${sortKeyName} BETWEEN ${sortValueName} AND ${sortValueName2}`;
    default:
    case "match":
      return `begins_with(${sortKeyName}, ${sortValueName})`;
  }
  throw new Error("unreachable");
};
async function find(ctx, collectionName, query, nextToken, options = {}) {
  var _a, _b, _c;
  const collection = getCollection(ctx, collectionName);
  const ap = findAccessPattern(collection, query);
  if (!ap) {
    throw new InvalidQueryException("Unable to find access pattern matching query", {
      collection: collectionName,
      query
    });
  }
  const layout = findAccessPatternLayout((_b = (_a = collection.layout) == null ? void 0 : _a.findKeys) != null ? _b : [], ap);
  if (!layout) {
    throw new ConfigurationException(`Unable to find layout for index specified in access pattern`, {
      info: { collectionName, indexName: ap.indexName }
    });
  }
  const partitionKeyValue = assembleQueryValue("partition", collection.name, query, ap.options || {}, ap.partitionKeys, collection.layout.indexKeySeparator);
  const sortKeyValue = assembleQueryValue("sort", collection.name, query, ap.options || {}, ap.sortKeys, collection.layout.indexKeySeparator);
  const sortKeyValue2 = (options == null ? void 0 : options.queryOperator) === "between" ? assembleQueryValue("sort2", collection.name, query, ap.options || {}, ap.sortKeys, collection.layout.indexKeySeparator) : void 0;
  const nameMapper = createNameMapper();
  const valueMapper = createValueMapper();
  const sortKeyOp = sortKeyValue && getQueryOperator(nameMapper.map(layout.sortKey, "#indexSortKey"), valueMapper.map(sortKeyValue), (options == null ? void 0 : options.queryOperator) === "between" ? valueMapper.map(sortKeyValue2) : void 0, options == null ? void 0 : options.queryOperator);
  const keyConditionExpression = `${nameMapper.map(layout.partitionKey, "#indexPartitionKey")} = ${valueMapper.map(partitionKeyValue)}${sortKeyValue ? ` AND ${sortKeyOp}` : ""}`;
  let filterExpression;
  if (options == null ? void 0 : options.filter) {
    filterExpression = parseCompositeCondition(options.filter, {
      nameMapper,
      valueMapper,
      parsePath: []
    });
  }
  const queryRequest = {
    TableName: collection.layout.tableName,
    IndexName: ap.indexName,
    KeyConditionExpression: keyConditionExpression,
    ExpressionAttributeNames: nameMapper.get(),
    ExpressionAttributeValues: valueMapper.get(),
    ExclusiveStartKey: nextToken,
    Limit: options == null ? void 0 : options.limit,
    ScanIndexForward: (_c = options == null ? void 0 : options.scanForward) != null ? _c : true,
    FilterExpression: filterExpression
  };
  debugDynamo_default("Query", queryRequest);
  const { Items: items, LastEvaluatedKey: lastEvaluatedKey } = await ctx.ddb.query(queryRequest).promise();
  const unwrappedItems = items ? items.map((item) => unwrap(import_dynamodb4.Converter.unmarshall(item, {
    convertEmptyValues: false
  }))) : [];
  return {
    items: unwrappedItems,
    nextToken: lastEvaluatedKey
  };
}

// src/operations/delete_by_id.ts
var import_dynamodb5 = require("aws-sdk/clients/dynamodb");
async function deleteById(context, collectionName, id, options = {}) {
  const collection = getRootCollection(context, collectionName);
  const nameMapper = createNameMapper();
  const valueMapper = createValueMapper();
  let conditionExpression;
  if (options.condition) {
    conditionExpression = parseCompositeCondition(options.condition, {
      nameMapper,
      valueMapper,
      parsePath: []
    });
  }
  const request = {
    TableName: collection.layout.tableName,
    Key: import_dynamodb5.Converter.marshall({
      [collection.layout.primaryKey.partitionKey]: assemblePrimaryKeyValue(collectionName, id, collection.layout.indexKeySeparator),
      [collection.layout.primaryKey.sortKey]: assemblePrimaryKeyValue(collectionName, id, collection.layout.indexKeySeparator)
    }, { convertEmptyValues: false }),
    ReturnValues: "ALL_OLD",
    ConditionExpression: conditionExpression,
    ExpressionAttributeNames: nameMapper.get(),
    ExpressionAttributeValues: valueMapper.get()
  };
  debugDynamo_default("DeleteItem", request);
  const result = await context.ddb.deleteItem(request).promise();
  if (result.Attributes) {
    const wrapped = import_dynamodb5.Converter.unmarshall(result.Attributes, {
      convertEmptyValues: false
    });
    return unwrap(wrapped);
  }
  return void 0;
}

// src/operations/replace.ts
var import_dynamodb6 = require("aws-sdk/clients/dynamodb");
async function replace(context, collectionName, value, options = {}) {
  const collection = getCollection(context, collectionName);
  const wrapped = toWrapped(collection, value);
  let conditionExpression;
  const nameMapper = createNameMapper();
  const valueMapper = createValueMapper();
  if (options.condition) {
    conditionExpression = parseCompositeCondition(options.condition, {
      nameMapper,
      valueMapper,
      parsePath: []
    });
  }
  const request = {
    TableName: collection.layout.tableName,
    Item: import_dynamodb6.Converter.marshall(wrapped),
    ReturnValues: "NONE",
    ConditionExpression: conditionExpression,
    ExpressionAttributeNames: nameMapper.get(),
    ExpressionAttributeValues: valueMapper.get()
  };
  debugDynamo_default("PutItem", request);
  await context.ddb.putItem(request).promise();
  return wrapped.value;
}

// src/operations/find_children.ts
var import_dynamodb7 = require("aws-sdk/clients/dynamodb");

// src/base/lexo.ts
var incrementLast = (x) => {
  var _a;
  if (x.length === 0) {
    return "\0";
  }
  const prefix = x.slice(0, x.length - 1);
  const lastCodePoint = (_a = x[x.length - 1].codePointAt(0)) != null ? _a : 0;
  if (lastCodePoint >= 65535) {
    return incrementLast(prefix) + String.fromCodePoint(0);
  } else {
    return prefix + String.fromCodePoint(lastCodePoint + 1);
  }
};
var decrementLast = (x) => {
  var _a;
  if (x.length === 0) {
    return "";
  }
  const prefix = x.slice(0, x.length - 1);
  const lastCodePoint = (_a = x[x.length - 1].codePointAt(0)) != null ? _a : 0;
  if (lastCodePoint === 0) {
    return decrementLast(prefix) + String.fromCodePoint(65535);
  } else {
    return prefix + String.fromCodePoint(lastCodePoint - 1);
  }
};

// src/operations/find_children.ts
async function findChildren(ctx, childCollectionName, rootObjectId, nextToken, options = {}) {
  var _a;
  const childCollection = getChildCollection(ctx, childCollectionName);
  const nameMapper = createNameMapper();
  const valueMapper = createValueMapper();
  const {
    parentCollectionName,
    layout: {
      primaryKey: { partitionKey, sortKey }
    }
  } = childCollection;
  const parentId = assemblePrimaryKeyValue(parentCollectionName, rootObjectId, childCollection.layout.indexKeySeparator);
  const partitionKeyExpression = `${nameMapper.map(partitionKey)} = ${valueMapper.map(parentId)}`;
  let sortKeyExpression;
  if (options.range) {
    switch (options.range.op) {
      case "gt": {
        const childCollectionMin = assemblePrimaryKeyValue(childCollectionName, incrementLast(options.range.value), childCollection.layout.indexKeySeparator);
        const childCollectionMax = assemblePrimaryKeyValue(childCollectionName, "\uFFFF", childCollection.layout.indexKeySeparator);
        sortKeyExpression = `${nameMapper.map(sortKey)} BETWEEN ${valueMapper.map(childCollectionMin)} AND ${valueMapper.map(childCollectionMax)}`;
        break;
      }
      case "lt": {
        const childCollectionMax = assemblePrimaryKeyValue(childCollectionName, decrementLast(options.range.value), childCollection.layout.indexKeySeparator);
        const childCollectionMin = assemblePrimaryKeyValue(childCollectionName, "", childCollection.layout.indexKeySeparator);
        sortKeyExpression = `${nameMapper.map(sortKey)} BETWEEN ${valueMapper.map(childCollectionMin)} AND ${valueMapper.map(childCollectionMax)}`;
        break;
      }
      case "lte": {
        const childCollectionMax = assemblePrimaryKeyValue(childCollectionName, options.range.value, childCollection.layout.indexKeySeparator);
        const childCollectionMin = assemblePrimaryKeyValue(childCollectionName, "", childCollection.layout.indexKeySeparator);
        sortKeyExpression = `${nameMapper.map(sortKey)} BETWEEN ${valueMapper.map(childCollectionMin)} AND ${valueMapper.map(childCollectionMax)}`;
        break;
      }
      case "gte": {
        const childCollectionMin = assemblePrimaryKeyValue(childCollectionName, options.range.value, childCollection.layout.indexKeySeparator);
        const childCollectionMax = assemblePrimaryKeyValue(childCollectionName, "\uFFFF", childCollection.layout.indexKeySeparator);
        sortKeyExpression = `${nameMapper.map(sortKey)} BETWEEN ${valueMapper.map(childCollectionMin)} AND ${valueMapper.map(childCollectionMax)}`;
        break;
      }
      case "begins_with": {
        const childCollectionValue = assemblePrimaryKeyValue(childCollectionName, options.range.value, childCollection.layout.indexKeySeparator);
        sortKeyExpression = `begins_with(${nameMapper.map(sortKey)}, ${valueMapper.map(childCollectionValue)})`;
        break;
      }
      case "between": {
        const childCollectionMin = assemblePrimaryKeyValue(childCollectionName, options.range.min, childCollection.layout.indexKeySeparator);
        const childCollectionMax = assemblePrimaryKeyValue(childCollectionName, options.range.max, childCollection.layout.indexKeySeparator);
        sortKeyExpression = `${nameMapper.map(sortKey)} BETWEEN ${valueMapper.map(childCollectionMin)} AND ${valueMapper.map(childCollectionMax)}`;
        break;
      }
      default:
        throw new InvalidRangeOperatorException("Unknown range operator", options.range.op);
    }
  } else {
    const childCollectionPrefix = assemblePrimaryKeyValue(childCollectionName, "", childCollection.layout.indexKeySeparator);
    sortKeyExpression = `begins_with(${nameMapper.map(sortKey)}, ${valueMapper.map(childCollectionPrefix)})`;
  }
  const keyConditionExpression = `${partitionKeyExpression} AND ${sortKeyExpression}`;
  const request = {
    TableName: childCollection.layout.tableName,
    KeyConditionExpression: keyConditionExpression,
    ExpressionAttributeNames: nameMapper.get(),
    ExpressionAttributeValues: valueMapper.get(),
    ExclusiveStartKey: nextToken,
    Limit: options == null ? void 0 : options.limit,
    ScanIndexForward: (_a = options == null ? void 0 : options.scanForward) != null ? _a : true
  };
  debugDynamo_default("Query", request);
  const results = await ctx.ddb.query(request).promise();
  return {
    items: (results.Items || []).map((item) => unwrap(import_dynamodb7.Converter.unmarshall(item, {
      convertEmptyValues: false
    }))),
    nextToken: results.LastEvaluatedKey
  };
}

// src/operations/find_child_by_id.ts
var import_dynamodb8 = require("aws-sdk/clients/dynamodb");
async function findChildById(context, collectionName, id, rootObjectId, options) {
  const collection = getChildCollection(context, collectionName);
  const request = {
    TableName: collection.layout.tableName,
    ConsistentRead: options == null ? void 0 : options.consistentRead,
    Key: import_dynamodb8.Converter.marshall({
      [collection.layout.primaryKey.partitionKey]: assemblePrimaryKeyValue(collection.parentCollectionName, rootObjectId, collection.layout.indexKeySeparator),
      [collection.layout.primaryKey.sortKey]: assemblePrimaryKeyValue(collectionName, id, collection.layout.indexKeySeparator)
    }, { convertEmptyValues: false })
  };
  debugDynamo_default("GetItem", request);
  const result = await context.ddb.getItem(request).promise();
  if (result.Item) {
    const wrapped = import_dynamodb8.Converter.unmarshall(result.Item, {
      convertEmptyValues: false
    });
    return unwrap(wrapped);
  }
  return void 0;
}

// src/operations/delete_child_by_id.ts
var import_dynamodb9 = require("aws-sdk/clients/dynamodb");
async function deleteChildById(context, collectionName, id, rootObjectId, options = {}) {
  const collection = getChildCollection(context, collectionName);
  const nameMapper = createNameMapper();
  const valueMapper = createValueMapper();
  let conditionExpression;
  if (options.condition) {
    conditionExpression = parseCompositeCondition(options.condition, {
      nameMapper,
      valueMapper,
      parsePath: []
    });
  }
  const request = {
    TableName: collection.layout.tableName,
    Key: import_dynamodb9.Converter.marshall({
      [collection.layout.primaryKey.partitionKey]: assemblePrimaryKeyValue(collection.parentCollectionName, rootObjectId, collection.layout.indexKeySeparator),
      [collection.layout.primaryKey.sortKey]: assemblePrimaryKeyValue(collectionName, id, collection.layout.indexKeySeparator)
    }, { convertEmptyValues: false }),
    ReturnValues: "ALL_OLD",
    ConditionExpression: conditionExpression,
    ExpressionAttributeNames: nameMapper.get(),
    ExpressionAttributeValues: valueMapper.get()
  };
  debugDynamo_default("DeleteItem", request);
  const result = await context.ddb.deleteItem(request).promise();
  if (result.Attributes) {
    const wrapped = import_dynamodb9.Converter.unmarshall(result.Attributes, {
      convertEmptyValues: false
    });
    return unwrap(wrapped);
  }
  return void 0;
}

// src/operations/update_by_id.ts
var import_get3 = __toESM(require("lodash/get"));
var import_debug2 = __toESM(require("debug"));
var import_dynamodb10 = require("aws-sdk/clients/dynamodb");
var debug2 = (0, import_debug2.default)("dynaglue:operations:updateById");
var makeKeyPath = (pathOrPathArray) => typeof pathOrPathArray === "string" ? pathOrPathArray.split(".") : pathOrPathArray;
var normaliseUpdates = (updatesToPerform) => {
  var _a, _b, _c, _d;
  if (updatesToPerform.$set || updatesToPerform.$delete) {
    const changesDocument = updatesToPerform;
    return {
      $set: (_b = (_a = changesDocument.$set) == null ? void 0 : _a.map((setUpdate) => [
        makeKeyPath(setUpdate[0]),
        setUpdate[1]
      ])) != null ? _b : [],
      $delete: (_d = (_c = changesDocument.$delete) == null ? void 0 : _c.map(makeKeyPath)) != null ? _d : []
    };
  } else {
    const updatesDocument = updatesToPerform;
    return {
      $set: Object.entries(updatesDocument).map(([key, value]) => [
        makeKeyPath(key),
        value
      ]),
      $delete: []
    };
  }
};
var extractUpdateKeyPaths = (changes) => [...changes.$set.map(([path]) => path), ...changes.$delete];
var getValueForUpdatePath = (matchingUpdatePath, keyPath, changes) => {
  const setPathIndex = changes.$set.findIndex(([setPath]) => isEqualKey(setPath, matchingUpdatePath));
  let value = setPathIndex >= 0 ? changes.$set[setPathIndex][1] : void 0;
  if (setPathIndex >= 0 && keyPath.length !== matchingUpdatePath.length) {
    const difference = keyPath.slice(matchingUpdatePath.length);
    value = (0, import_get3.default)(value, difference);
  }
  return value;
};
var createUpdateActionForKey = (collectionName, keyType, keyPaths, indexLayout, changes, separator) => {
  const updateKeyPaths = extractUpdateKeyPaths(changes);
  const matchingUpdatePaths = keyPaths.map((partitionKey) => findMatchingPath(updateKeyPaths, partitionKey));
  const attributeName = keyType === "sort" ? indexLayout.sortKey : indexLayout.partitionKey;
  debug2("createUpdateActionForKey: collection=%s keyType=%s keyPaths=%o attributeName=%s", collectionName, keyType, keyPaths, attributeName);
  if (matchingUpdatePaths.every((updatePath) => typeof updatePath === "undefined")) {
    debug2("createUpdateActionForKey: no updates to %s key in collection %s", keyType, collectionName);
    return void 0;
  }
  debug2("createUpdateActionForKey: key to be updated matchingUpdatePaths=%o", matchingUpdatePaths);
  const updateValues = keyPaths.map((keyPath, index) => {
    const matchingUpdatePath = matchingUpdatePaths[index];
    if (!matchingUpdatePath) {
      return void 0;
    }
    return getValueForUpdatePath(matchingUpdatePath, keyPath, changes);
  });
  return {
    attributeName,
    value: assembleIndexedValue(keyType, collectionName, updateValues, separator),
    valueErasure: updateValues.every((value) => typeof value === "undefined")
  };
};
var createUpdateActionForTTLKey = (attributeName, keyPath, updates) => {
  const updateKeyPaths = extractUpdateKeyPaths(updates);
  const matchingUpdatePath = findMatchingPath(updateKeyPaths, keyPath);
  if (matchingUpdatePath) {
    const value = getValueForUpdatePath(matchingUpdatePath, keyPath, updates);
    return {
      attributeName,
      value: value ? transformTTLValue(value) : void 0
    };
  }
  return void 0;
};
var findCollectionIndex = (collection, indexName) => {
  var _a;
  const layout = (_a = collection.layout.findKeys) == null ? void 0 : _a.find((fk) => fk.indexName === indexName);
  if (!layout) {
    throw new IndexNotFoundException(indexName);
  }
  return layout;
};
var mapAccessPatterns = (collection, {
  nameMapper,
  valueMapper
}, changes) => {
  const expressionSetActions = [];
  const expressionDeleteActions = [];
  const { accessPatterns = [], ttlKeyPath } = collection;
  for (const { indexName, partitionKeys, sortKeys } of accessPatterns) {
    let partitionKeyUpdateSet = void 0;
    let sortKeyUpdated = false;
    const layout = findCollectionIndex(collection, indexName);
    if (partitionKeys.length > 0) {
      const update = createUpdateActionForKey(collection.name, "partition", partitionKeys, layout, changes, collection.layout.indexKeySeparator);
      if (update) {
        partitionKeyUpdateSet = !update.valueErasure;
        debug2("mapAccessPatterns: adding set/delete action for partition key in collection %s: %o", collection.name, update);
        const nameMapping = nameMapper.map(update.attributeName);
        const valueMapping = valueMapper.map(update.value);
        expressionSetActions.push(`${nameMapping} = ${valueMapping}`);
      }
    }
    if (sortKeys && sortKeys.length > 0) {
      const update = createUpdateActionForKey(collection.name, "sort", sortKeys, layout, changes, collection.layout.indexKeySeparator);
      if (update) {
        debug2("mapAccessPatterns: adding set/delete action for sort key in collection %s: %o", collection.name, update);
        sortKeyUpdated = true;
        if (typeof update.value !== "undefined") {
          const nameMapping = nameMapper.map(update.attributeName);
          const valueMapping = valueMapper.map(update.value);
          expressionSetActions.push(`${nameMapping} = ${valueMapping}`);
        } else {
          const nameMapping = nameMapper.map(update.attributeName);
          expressionDeleteActions.push(nameMapping);
        }
      }
    } else if (typeof partitionKeyUpdateSet !== "undefined" && layout.sortKey) {
      const nameMapping = nameMapper.map(layout.sortKey);
      if (partitionKeyUpdateSet) {
        const valueMapping = valueMapper.map(assembleIndexedValue("sort", collection.name, [], collection.layout.indexKeySeparator));
        expressionSetActions.push(`${nameMapping} = ${valueMapping}`);
      } else {
        expressionDeleteActions.push(nameMapping);
      }
    }
    if (sortKeyUpdated && (!partitionKeys || partitionKeys.length === 0)) {
      const nameMapping = nameMapper.map(layout.partitionKey);
      const valueMapping = valueMapper.map(assembleIndexedValue("partition", collection.name, [], collection.layout.indexKeySeparator));
      expressionSetActions.push(`${nameMapping} = ${valueMapping}`);
    }
  }
  if (ttlKeyPath) {
    const updateAction = createUpdateActionForTTLKey(collection.layout.ttlAttribute, ttlKeyPath, changes);
    if (updateAction) {
      const nameMapping = nameMapper.map(updateAction.attributeName);
      if (updateAction.value) {
        const valueMapping = valueMapper.map(updateAction.value);
        expressionSetActions.push(`${nameMapping} = ${valueMapping}`);
      } else {
        expressionDeleteActions.push(nameMapping);
      }
    }
  }
  return {
    setActions: expressionSetActions,
    deleteActions: expressionDeleteActions
  };
};
async function updateInternal(ctx, collection, key, updatesToPerform, options) {
  const changes = normaliseUpdates(updatesToPerform);
  if (changes.$set.length === 0 && changes.$delete.length === 0) {
    throw new InvalidUpdatesException("There must be at least one update path in the updates object");
  }
  const nameMapper = createNameMapper();
  const valueMapper = createValueMapper();
  let expressionSetActions = [];
  let expressionDeleteActions = [];
  for (const [path, newValue] of changes.$set.values()) {
    if (typeof newValue === "undefined") {
      throw new InvalidUpdateValueException(path.join("."), "value must not be undefined");
    }
    const valueName = valueMapper.map(newValue);
    const expressionAttributeNameParts = [
      nameMapper.map("value", "#value"),
      ...path.map((part) => nameMapper.map(part))
    ];
    expressionSetActions.push(`${expressionAttributeNameParts.join(".")} = ${valueName}`);
  }
  for (const path of changes.$delete) {
    const expressionAttributeNameParts = [
      nameMapper.map("value", "#value"),
      ...path.map((part) => nameMapper.map(part))
    ];
    expressionDeleteActions.push(`${expressionAttributeNameParts.join(".")}`);
  }
  const {
    setActions: additionalSetActions,
    deleteActions: additionalDeleteActions
  } = mapAccessPatterns(collection, { nameMapper, valueMapper }, changes);
  expressionSetActions = [...expressionSetActions, ...additionalSetActions];
  expressionDeleteActions = [
    ...expressionDeleteActions,
    ...additionalDeleteActions
  ];
  let conditionExpression;
  if (options.condition) {
    conditionExpression = parseCompositeCondition(options.condition, {
      nameMapper,
      valueMapper,
      parsePath: []
    });
  }
  const expressionAttributeNames = nameMapper.get();
  const expressionAttributeValues = valueMapper.get();
  const updateExpression = (expressionSetActions.length ? ` SET ${expressionSetActions.join(", ")}` : "") + (expressionDeleteActions.length ? ` REMOVE ${expressionDeleteActions.join(", ")}` : "");
  const updateItem = {
    TableName: collection.layout.tableName,
    Key: key,
    ReturnValues: "ALL_NEW",
    ExpressionAttributeNames: expressionAttributeNames,
    ExpressionAttributeValues: expressionAttributeValues,
    UpdateExpression: updateExpression.trim(),
    ConditionExpression: conditionExpression
  };
  debugDynamo_default("UpdateItem", updateItem);
  const result = await ctx.ddb.updateItem(updateItem).promise();
  const unmarshalledAttributes = import_dynamodb10.Converter.unmarshall(result.Attributes, { convertEmptyValues: false });
  const updatedDocument = unwrap(unmarshalledAttributes);
  return updatedDocument;
}
async function updateById(ctx, collectionName, objectId, updates, options = {}) {
  const collection = getRootCollection(ctx, collectionName);
  const key = {
    [collection.layout.primaryKey.partitionKey]: {
      S: assemblePrimaryKeyValue(collectionName, objectId, collection.layout.indexKeySeparator)
    },
    [collection.layout.primaryKey.sortKey]: {
      S: assemblePrimaryKeyValue(collectionName, objectId, collection.layout.indexKeySeparator)
    }
  };
  return updateInternal(ctx, collection, key, updates, options);
}

// src/operations/update_child_by_id.ts
async function updateChildById(context, collectionName, objectId, parentObjectId, updates, options = {}) {
  const collection = getChildCollection(context, collectionName);
  const key = {
    [collection.layout.primaryKey.partitionKey]: {
      S: assemblePrimaryKeyValue(collection.parentCollectionName, parentObjectId, collection.layout.indexKeySeparator)
    },
    [collection.layout.primaryKey.sortKey]: {
      S: assemblePrimaryKeyValue(collectionName, objectId, collection.layout.indexKeySeparator)
    }
  };
  return updateInternal(context, collection, key, updates, options);
}

// src/operations/find_by_id_with_children.ts
var import_dynamodb11 = require("aws-sdk/clients/dynamodb");
var import_fromPairs = __toESM(require("lodash/fromPairs"));
var findByIdWithChildren = async (ctx, rootCollectionName, rootObjectId, childCollectionNames, nextToken, options = {}) => {
  var _a, _b;
  const collection = getCollection(ctx, rootCollectionName);
  let childCollections;
  if (childCollectionNames) {
    childCollections = childCollectionNames.map((name) => getChildCollection(ctx, name));
    for (const childCollection of childCollections) {
      if (childCollection.parentCollectionName !== rootCollectionName) {
        throw new CollectionNotFoundException(childCollection.name);
      }
    }
  } else {
    childCollections = [...ctx.childDefinitions.values()].filter((collection2) => collection2.parentCollectionName === rootCollectionName);
  }
  const allChildCollectionNames = childCollections.map((collection2) => collection2.name);
  const allCollectionNames = [
    rootCollectionName,
    ...allChildCollectionNames
  ].sort();
  const firstCollection = allCollectionNames[0];
  const lastCollection = allCollectionNames[allCollectionNames.length - 1];
  const lastCollectionBound = assemblePrimaryKeyValue(lastCollection, "\uFFFF", collection.layout.indexKeySeparator);
  const nameMapper = createNameMapper();
  const valueMapper = createValueMapper();
  const { partitionKey, sortKey } = collection.layout.primaryKey;
  const keyConditionExpression = `${nameMapper.map(partitionKey)} = ${valueMapper.map(assemblePrimaryKeyValue(rootCollectionName, rootObjectId, collection.layout.indexKeySeparator))} AND ${nameMapper.map(sortKey)} BETWEEN ${valueMapper.map(assemblePrimaryKeyValue(firstCollection, "", collection.layout.indexKeySeparator))} AND ${valueMapper.map(lastCollectionBound)}`;
  const filterExpression = `${nameMapper.map("type")} IN (${allCollectionNames.map((c) => valueMapper.map(c)).join(",")})`;
  const request = {
    TableName: collection.layout.tableName,
    KeyConditionExpression: keyConditionExpression,
    ExpressionAttributeNames: nameMapper.get(),
    ExpressionAttributeValues: valueMapper.get(),
    ExclusiveStartKey: nextToken,
    Limit: options == null ? void 0 : options.limit,
    ScanIndexForward: (_a = options == null ? void 0 : options.scanForward) != null ? _a : true,
    FilterExpression: filterExpression
  };
  debugDynamo_default("Query", request);
  const { Items = [], LastEvaluatedKey } = await ctx.ddb.query(request).promise();
  let root;
  const children = (0, import_fromPairs.default)(allChildCollectionNames.map((name) => [name, []]));
  for (const item of Items) {
    const attributes = import_dynamodb11.Converter.unmarshall(item, {
      convertEmptyValues: false
    });
    if (attributes.type === rootCollectionName) {
      root = unwrap(attributes);
    } else {
      children[attributes.type] = (_b = children[attributes.type]) != null ? _b : [];
      children[attributes.type].push(unwrap(attributes));
    }
  }
  return {
    root,
    children,
    nextToken: LastEvaluatedKey
  };
};

// src/operations/batch_find_by_ids.ts
var import_dynamodb13 = require("aws-sdk/clients/dynamodb");

// src/operations/batch_utils.ts
var import_dynamodb12 = require("aws-sdk/clients/dynamodb");
var parseKey = (layout, key) => {
  var _a, _b;
  const partitionKey = import_dynamodb12.Converter.output(key[layout.primaryKey.partitionKey], {
    convertEmptyValues: false
  });
  const sortKey = import_dynamodb12.Converter.output(key[layout.primaryKey.sortKey], {
    convertEmptyValues: false
  });
  if (!partitionKey || !sortKey)
    throw new InternalProcessingException(`Selected layout could not find key names ${JSON.stringify(key)} for table ${layout.tableName}`);
  if (typeof partitionKey !== "string")
    throw new InternalProcessingException(`Partition key ${layout.primaryKey.partitionKey} for table ${layout.tableName} is not a string`);
  if (typeof sortKey !== "string")
    throw new InternalProcessingException(`Sort key ${layout.primaryKey.sortKey} for table ${layout.tableName} is not a string`);
  const [, parentId] = partitionKey.split((_a = layout.indexKeySeparator) != null ? _a : SEPARATOR, 2);
  const [childCollection, id] = sortKey.split((_b = layout.indexKeySeparator) != null ? _b : SEPARATOR, 2);
  return {
    collection: childCollection,
    parentId: parentId !== id ? parentId : void 0,
    id
  };
};

// src/operations/batch_find_by_ids.ts
var batchFindByIds = async (ctx, items, options) => {
  var _a;
  if (items.length === 0) {
    throw new InvalidFindDescriptorException("At least one find descriptor must be specified");
  } else if (items.length > 100) {
    throw new InvalidFindDescriptorException("No more than 100 find descriptors can be specified to batchFindByIds");
  }
  const tableLayoutMapping = /* @__PURE__ */ new Map();
  const tableRequestItemTuples = items.map(({ collection, id, parentId }) => {
    const collectionDefinition = parentId ? getChildCollection(ctx, collection) : getRootCollection(ctx, collection);
    tableLayoutMapping.set(collectionDefinition.layout.tableName, collectionDefinition.layout);
    const {
      layout: { tableName, primaryKey, indexKeySeparator }
    } = collectionDefinition;
    return [
      tableName,
      {
        [primaryKey.partitionKey]: import_dynamodb13.Converter.input(assemblePrimaryKeyValue(collectionDefinition.type === "child" ? collectionDefinition.parentCollectionName : collectionDefinition.name, parentId ? parentId : id, indexKeySeparator), { convertEmptyValues: false }),
        [primaryKey.sortKey]: import_dynamodb13.Converter.input(assemblePrimaryKeyValue(collection, id, indexKeySeparator), { convertEmptyValues: false })
      }
    ];
  });
  const requestItems = tableRequestItemTuples.reduce((req, tuple) => {
    var _a2, _b;
    const keyAndsAttrs = (_b = req[tuple[0]]) != null ? _b : {
      ConsistentRead: ((_a2 = options == null ? void 0 : options.consistentReadTableNames) != null ? _a2 : []).includes(tuple[0]),
      Keys: []
    };
    req[tuple[0]] = keyAndsAttrs;
    keyAndsAttrs.Keys.push(tuple[1]);
    return req;
  }, {});
  const request = { RequestItems: requestItems };
  debugDynamo_default("batchGetItem", request);
  const { Responses = {}, UnprocessedKeys = {} } = await ctx.ddb.batchGetItem(request).promise();
  const response = {
    documentsByCollection: {},
    unprocessedDescriptors: []
  };
  for (const items2 of Object.values(Responses)) {
    for (const item of items2) {
      const unmarshalled = import_dynamodb13.Converter.unmarshall(item, {
        convertEmptyValues: false
      });
      const collection = getCollection(ctx, unmarshalled.type);
      const document = unwrap(unmarshalled);
      const collectionMap = (_a = response.documentsByCollection[collection.name]) != null ? _a : [];
      response.documentsByCollection[collection.name] = collectionMap;
      collectionMap.push(document);
    }
  }
  for (const [tableName, unprocessed] of Object.entries(UnprocessedKeys)) {
    const tableMapping = tableLayoutMapping.get(tableName);
    if (!tableMapping) {
      throw new InternalProcessingException(`Could not find table mapping for ${tableName} while parsing UnprocessedKeys`);
    }
    for (const key of unprocessed.Keys) {
      const descriptor = parseKey(tableMapping, key);
      response.unprocessedDescriptors.push(descriptor);
    }
  }
  return response;
};

// src/operations/batch_replace_delete.ts
var import_dynamodb14 = require("aws-sdk/clients/dynamodb");
var batchReplaceDelete = async (ctx, descriptors) => {
  if (descriptors.length === 0) {
    throw new InvalidBatchReplaceDeleteDescriptorException("You must specify at least one replace or delete descriptor");
  }
  const tableLayoutMapping = /* @__PURE__ */ new Map();
  const tableRequestItemTuples = descriptors.map((descriptor) => {
    var _a;
    const collection = getCollection(ctx, descriptor.collection);
    tableLayoutMapping.set(collection.layout.tableName, collection.layout);
    let request2;
    if (descriptor.op === "replace") {
      request2 = {
        PutRequest: {
          Item: import_dynamodb14.Converter.marshall(toWrapped(collection, descriptor.replaceItem), { convertEmptyValues: false })
        }
      };
    } else {
      if (collection.type === "child" && !descriptor.parentId) {
        throw new InvalidBatchReplaceDeleteDescriptorException("BatchDeleteDescriptor must specify parentId for child collections", { collectionName: descriptor.collection, id: descriptor.id });
      } else if (collection.type !== "child" && descriptor.parentId) {
        throw new InvalidBatchReplaceDeleteDescriptorException("BatchDeleteDescriptor must not specify parentId for root collections", { collectionname: descriptor.collection, id: descriptor.id });
      }
      const partitionKeyValue = assemblePrimaryKeyValue(collection.type === "child" ? collection.parentCollectionName : collection.name, (_a = descriptor.parentId) != null ? _a : descriptor.id, collection.layout.indexKeySeparator);
      const sortKeyValue = assemblePrimaryKeyValue(collection.name, descriptor.id, collection.layout.indexKeySeparator);
      request2 = {
        DeleteRequest: {
          Key: import_dynamodb14.Converter.marshall({
            [collection.layout.primaryKey.partitionKey]: partitionKeyValue,
            [collection.layout.primaryKey.sortKey]: sortKeyValue
          }, { convertEmptyValues: false })
        }
      };
    }
    return [collection.layout.tableName, request2];
  });
  const requestItems = tableRequestItemTuples.reduce((riMap, [table, request2]) => {
    var _a;
    const items = (_a = riMap[table]) != null ? _a : [];
    riMap[table] = items;
    items.push(request2);
    return riMap;
  }, {});
  const request = {
    RequestItems: requestItems
  };
  debugDynamo_default("batchWriteItem", request);
  const { UnprocessedItems = {} } = await ctx.ddb.batchWriteItem(request).promise();
  const unprocessedDescriptors = [];
  for (const [tableName, unprocessed] of Object.entries(UnprocessedItems)) {
    const tableMapping = tableLayoutMapping.get(tableName);
    if (!tableMapping) {
      throw new InternalProcessingException(`Could not find table mapping for ${tableName} while parsing UnprocessedKeys`);
    }
    for (const item of unprocessed) {
      const { PutRequest, DeleteRequest } = item;
      if (PutRequest) {
        const key = parseKey(tableMapping, PutRequest.Item);
        const wrapped = import_dynamodb14.Converter.unmarshall(PutRequest.Item, {
          convertEmptyValues: false
        });
        const document = unwrap(wrapped);
        unprocessedDescriptors.push({
          op: "replace",
          replaceItem: document,
          collection: key.collection
        });
      } else if (DeleteRequest) {
        const key = parseKey(tableMapping, DeleteRequest.Key);
        unprocessedDescriptors.push(__spreadValues({
          op: "delete"
        }, key));
      }
    }
  }
  return {
    unprocessedDescriptors
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CollectionNotFoundException,
  ConfigurationException,
  ConflictException,
  IndexNotFoundException,
  InvalidBatchReplaceDeleteDescriptorException,
  InvalidCompositeConditionException,
  InvalidIdException,
  InvalidIndexedFieldValueException,
  InvalidParentIdException,
  InvalidQueryException,
  InvalidUpdateValueException,
  InvalidUpdatesException,
  batchFindByIds,
  batchReplaceDelete,
  createContext,
  deleteById,
  deleteChildById,
  find,
  findById,
  findByIdWithChildren,
  findChildById,
  findChildren,
  insert,
  replace,
  updateById,
  updateChildById
});
//# sourceMappingURL=index.js.map
